var px2rem = require('postcss-px2rem');
const fs = require('fs');
let target = require('./package')['proxy-target'];// 读代理地址
var proxy = require('http-proxy-middleware');

const poststylus = require('poststylus');
// const pxtorem = require('postcss-pxtorem');
const path = require('path')
function resolvePath (dir) {
  return path.join(__dirname, dir)
}
const themePath = resolvePath('theme.custom.styl');// 解析主题stylus的绝对路径

exports.pluginName = '@ali/kylin-plugin-custom';
exports.default = function () {
  return {
    // 修改 webpack 配置
    webpack: function modifyWebpackConfig(webpackConfig) {
      //  如果要开启 px2rem, cnpm i --save-dev postcss-px2rem 安装该模块并取消下面的注释
      webpackConfig.vue.postcss.push(
        px2rem({
          remUnit: 100
        })
      );
      webpackConfig.module.loaders.push({
        // 'test': /.*venus.*\.js$/,
        'test': /\.js$/,
        'loader': 'babel-loader',
        'include': /node_modules\/.*venusui/
      });

      webpackConfig.module.loaders.push({
        'test': /\.js$/,
        'loader': 'babel-loader',
        'include': /node_modules\/.*mand-mobile/
      });
      webpackConfig.module.loaders.push({
        'test': /\.styl(us)?$/,
        'loader': 'vue-style-loader!css-loader!stylus-loader',
        'include': /node_modules\/.*mand-mobile/
      });
      webpackConfig.module.loaders.push({
        test: /\.(png|jpe?g|gif)(\?.*)?$/,
        loader: 'url-loader',
        include: /node_modules\/.*mand-mobile/
      });
      // stylus loader 的配置全局传入，这是webpack1的语法
      webpackConfig.stylus = {
        import: [themePath]// 传入定制化信息
      };

      let str = JSON.stringify(webpackConfig);
      fs.writeFile('_webpackConfig_Mirror.json', str, {}, () => {
      });// add by longbo输出配置为文件

      return webpackConfig;
    },

    // 修改 babel 配置
    babel: function modifyBabelConfig(babelConfig) {
      // 配置babel-plugin-import， 确保引入组件源码,it works, dont't touch
      babelConfig.plugins[0][1].push({'libraryName': 'mand-mobile', 'libraryDirectory': 'components'});

      let str = JSON.stringify(babelConfig);
      fs.writeFile('_babelConfig_Mirror.json', str, {}, () => {
      });// add by longbo输出配置为文件

      return babelConfig;
    },

    //  接入 express 插件, 依赖 build@ 0.1.49+ 及以上版本
    express: function modifyExpress(expressInstance) {
      //  如果要使用 http-proxy-middleware, cnpm i --save-dev http-proxy-middleware 安装该模块并取消下面的注释

      expressInstance.use(
        proxy(['/webapi', '/team4'], {target: target})
      );

      // // http://localhost:8090/api/foo/bar -> http://localhost:3000/api/foo/bar
    },
  };
};
